using System;

namespace estoque
{
    /// <summary>
    /// EventArgument, die eine neue Nachricht mitbringen
    /// </summary>
    public class TracerMessageChangedEventArgs : EventArgs
    {
        private string message;

        /// <summary>
        /// Der neue Loggingeintrag
        /// </summary>
        public string Message
        {
            get { return message; }
            set { message = value; }
        }

        /// <summary>
        /// Instanziert ein EventArgument, das eine neue Nachricht mitbringt
        /// </summary>
        public TracerMessageChangedEventArgs(string message)
        {
            this.message = message;
        }
    }
}