using System;

namespace estoque
{
    /// <summary>
    /// EventArgumente, die einen neuen TracerStatus oder eine neue Nachricht mitbringen
    /// </summary>
    public class TracerStatusChangedEventArgs : EventArgs
    {
        private TracerStatus status;

        /// <summary>
        /// Der neue Status
        /// </summary>
        public TracerStatus Status
        {
            get { return status; }
            set { status = value; }
        }

        /// <summary>
        /// Instanziert ein EventArgument, das einen neuen TracerStatus mitbringt
        /// </summary>
        /// <param name="status"></param>
        public TracerStatusChangedEventArgs(TracerStatus status)
        {
            this.status = status;
        }
    }
}