﻿using System;
using System.Globalization;
using System.Threading;
using System.Windows.Data;

namespace estoque
{
    public class TimeSpanConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            TimeSpan date = (TimeSpan)value;
            string content = date.ToString("hh\\:mm", Thread.CurrentThread.CurrentCulture);

            return content;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string strValue = value.ToString();
            TimeSpan resultDateTime;

            if (TimeSpan.TryParse(strValue, Thread.CurrentThread.CurrentCulture, out resultDateTime))
            {
                return resultDateTime;
            }

            return value;
        }
    }
}